#include "hmg.ch"

*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT ,SDDODBC, SQLMIX
  RDDSETDEFAULT( "DBFCDX" , "SQLMIX" )

*------------------------------------------------------------*
 Function CreateReport() 
*------------------------------------------------------------*

*------------------------------------------------------------*
*------------------------------------------------------------*
* Gentileza Cdigo Listado ---> Amarante Araruama-RJ, Brazil *
*------------------------------------------------------------*
*------------------------------------------------------------*

LOCAL _oDB_
LOCAL aReturn_Sql
LOCAL aDataRecord
LOCAL nCurrentRecord
LOCAL nTotalRecords
LOCAL cQuery_

LOCAL ID
LOCAL NAME
LOCAL CHARGE
LOCAL PASSWORD
LOCAL PHOTO
LOCAL NIVEL


/*------------------------
  Access SQLITE DataBase
------------------------*/
_oDB_ := connect2db( "control.sqlite" )
IF _oDB_ == NIL
    MsgStop( 'Error connection failure','Error Connection !')
  return
ENDIF

*--------------------------------- Nom Listado Pdf -----------------------------------------*
PRIVATE pagina  := 0
PRIVATE F_Mus   := 60

PRIVATE FDIA
PRIVATE FDIAx
PRIVATE HORA
PRIVATE HORAx
PUBLIC  cNumero

FDIA    := DTOC(DATE())
FDIAx   := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/)
HORA    := LEFT(TIME(), 5)
HORAx   := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:)
cNombre := "Listado_Pdf\" + "Listado" + "_" + FDIAx + '_' + HORAx + '.pdf'
cNumero := (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------*
SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4
*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*
* SET HPDFDOC ENCODING TO "WinAnsiEncoding"
  SET HPDFDOC ENCODING TO "CP1252"
*---------------------------------------------------------------------------------------------*


/*--- Counters ---*/
nCurrentRecord := 0
nTotalRecords  := VAL( Sqlite_Cmd( _oDB_, "SELECT COUNT(*)" )[ 1, 1 ] )

/*---------------------------------------------------
  Select query
  Note that the clause "ORDER BY id" is unnecessary
  because "ID" is part of the primary key
---------------------------------------------------*/

 cQuery_ := "SELECT id ,NAME,CHARGE, PASSWORD, PHOTO, NIVEL,NOTAS FROM control ORDER BY id"


/*--- When you run the select data in return array ---*/
aReturn_Sql := Sqlite_Cmd( _oDB_, cQuery_  )


/*--- starts Document ---*/
START HPDFDOC

  /*--- start Page ---*/
  START HPDFPAGE

    /*--- Loop Reading Records ---*/
    FOR EACH aDataRecord IN aReturn_Sql

      /*--- Store Data ---*/

      ID        := aDataRecord[ 1 ]
      NAME      := aDataRecord[ 2 ]
      CHARGE    := aDataRecord[ 3 ]
      PASSWORD  := aDataRecord[ 4 ]
      PHOTO     := aDataRecord[ 5 ]
      NIVEL     := aDataRecord[ 6 ]


      /*--- Next Record ---*/
      nCurrentRecord ++

      /*--- Headline ---*/
      IF F_Mus == 60
        *--------------------------------------- Cuadro General ------------------------------------------------------*
        @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1
        @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1
        *-------------------------------------------------------------------------------------------------------------*
        @ 021,037 HPDFPRINT IMAGE "Resource\Logo.png" width 12 height 12
        @ 030,065 HPDFPRINT "Listado Base Datos"  FONT "Times-Roman" SIZE 25 ITALIC
        @ 030,142 HPDFPRINT dtoc(DATE()) FONT "Times-Roman" SIZE 18 ITALIC
        @ 040,015 HPDFPRINT RECTANGLE TO 48, 197  ROUNDED CURVE 1
        @ 045,022 HPDFPRINT "N                       NAME                                       CHARGE" FONT "Times-Roman" SIZE 9 ITALIC
        @ 045,127 HPDFPRINT "PASSWORD         PHOTO                 NIVEL"  FONT "Times-Roman" SIZE 9 ITALIC
        *------------------------------------------ EnD ---------------------------------------------------------------*
        *----------------------------------------------------n pagina  -----------------------------------------------*
        pagina ++
        @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC
        *--------------------------------------------------------------------------------------------------------------*
      ENDIF

      *------------------------------------------------------------------------------------*
      *--------------------------------------- Database  Names ----------------------------*
      *------------------------------------------------------------------------------------*

        *--------------------------------------- ID --------------------------------*
        @ F_Mus, 014 HPDFPRINT STR( ID, 8 ) FONT "Times-Roman" SIZE 12 ITALIC
        *------------------------------------- NAME --------------------------------*

        Busqui := CamelCase( NAME ,.T.,{"_",".","-","/","\"})    
    
        @ F_Mus, 035 HPDFPRINT RTRIM( Busqui) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 078 HPDFPRINT RTRIM(CHARGE) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 129 HPDFPRINT RTRIM(PASSWORD) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 150 HPDFPRINT SUBSTR(PHOTO, 8, 6) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 167 HPDFPRINT SUBSTR(NIVEL,10,11) FONT "Times-Roman" SIZE 12 ITALIC

      *-----------------------------------------------------------------------------*
      *-------------------------------- End Database Names -------------------------*
      *-----------------------------------------------------------------------------*
      
      /*--- Increases a printed line on the page and footer tests ---*/
      F_Mus += 4
      IF F_Mus > ( 60 + 210 )   // <--------------- Salto de Pgina
        F_Mus := 60
        /*--- Closes Previous Page ---*/
        END HPDFPAGE
        /*--- start New Page ---*/
        START HPDFPAGE
      ENDIF

    NEXT aDataRecord

  /*--- Closes Previous Page ---*/
  END HPDFPAGE

/*--- Closes Document ---*/
END HPDFDOC

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*

   Execute File cNombre

   *alternativa direccion directa a impresora el PDF

   *SHELLEXECUTE( 0, "print" ,   cNombre ) //  ---> 'sample.pdf'

RETURN Nil

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
